% An chinese automated version of the operation span task.
%Gaoxing Mei--2020/05/10
%modified by Gaoxing Mei--2020/12/8. add "double" before the chinese texts for normally displaying chinese in recent versions of MATLAB.
%modified by Shiming Qiu--2021/3/24. '\n\n\n\n' can't be used directly in the function of "DrawFormattedText" in MATLAB2018b, so we writed the content which would
%be presented in the screen before using "DrawFormattedText".
%contact email: meigx@gznu.edu.cn
clear all;clc
commandwindow;tic;
oldEnableFlag = Screen('Preference', 'TextAntiAliasing', 0);
KbName('UnifyKeyNames');
global  w   fixpos screenRect

fid = fopen('AospanChinese.m','r');
mycode= fscanf(fid,'%300c');
fclose('all');
homedir = pwd;
addpath(pwd);
% prompt={'\fontsize{10} ƴ+[1-1000]zhangsan1:','\fontsize{10} ڼβ?'};
prompt={'\fontsize{10} Input the name of the subjecte.g, zhangsan1:','\fontsize{10}  which test?e.g, 1'};
ioption.Resize='on';
ioption.Interpreter='tex';
nsub_nTest=inputdlg(prompt,'',1,{'',''},ioption);
cd Data
while 1
    if ~exist(nsub_nTest{1}, 'dir')
        mkdir(nsub_nTest{1});
        break
    else
        button=questdlg(['Ա' nsub_nTest{1}  'ѾڣҪ?'],'','','','');
        if strcmp(button,'')
            break
        else
            nsub_nTest=inputdlg(prompt,'',1,{'',''},ioption);
        end
    end
end
cd ..
screens = Screen('Screens');screenNumber = max(screens);
[width, heighth]= Screen('DisplaySize',screenNumber);
monitor.fRate = Screen('FrameRate',screenNumber);
bkgcol = GrayIndex(screenNumber);
monitor.oldclut = Screen('ReadNormalizedGammaTable',screenNumber);
try
    AssertOpenGL;
    Screen('Preference', 'SkipSyncTests', 1);
    PsychImaging('PrepareConfiguration');
    PsychImaging('AddTask', 'AllViews', 'EnableCLUTMapping');
    [w, screenRect] = PsychImaging('OpenWindow', screenNumber,255, [], [], [], []);
    Screen('LoadNormalizedGammaTable',w,monitor.oldclut,2);
    Priority(MaxPriority(w));
    monitor.center = CenterRect([0 0 1 1],screenRect);
    
    % to match different  screen resolutions  when setting fontsize.
    if screenRect (3)<=1200
        fontsize=25;
    elseif screenRect (3)>1200 && screenRect(3) <=1500
        fontsize=27;
    elseif screenRect (3)>1500
        fontsize=32;
    end
    Screen('TextSize', w ,fontsize);
    Screen('TextFont',w,'Times New Roman');
    fixpos = [monitor.center(1) monitor.center(2)];
    
    %set position parameters of the black frame around the math problems.
    penWidth=[10 2];
    offlineSE=[7 15];% [start end] ,shift how many pixels when drawing line instead of forgotten letters in the recall screen.
    lineWidth=2;
    blackFramePos=[fixpos(1)-fixpos(1)*.7-penWidth(1)  fixpos(2)-fixpos(2)*.7-penWidth(1) fixpos(1)+fixpos(1)*.7+penWidth(1)  fixpos(2)+fixpos(2)*.7+penWidth(1)];
    offdisX=20;
    offdisY=10;
    correctPosX=round(2*fixpos(1)*(3/8));
    correctPosY=fixpos(2);
    [~, ~, textbounds1]= DrawFormattedText(w,  'ȷ', correctPosX, correctPosY, 0);
    wrongPosX=fixpos(1)+ (fixpos(1)-(correctPosX+(textbounds1(3)-textbounds1(1))));
    [~, ~, textbounds2] =DrawFormattedText(w,  '', wrongPosX, correctPosY, 0);
    ansFrameLeftPos=[textbounds1(1)-offdisX  textbounds1(2)-offdisY   textbounds1(3)+offdisX  textbounds1(2)+2*(textbounds1(4)-textbounds1(2))];
    ansFrameRightPos=[textbounds2(1)-offdisX  textbounds1(2)-offdisY    textbounds2(3)+offdisX textbounds1(2)+2*(textbounds1(4)-textbounds1(2))];
    
    % set postion parameters of letter frames in the recall screen.
    xF1=round(fixpos(1)*.42);%x shift distance for left position :"F" button in the recall screen.
    xF2=round(fixpos(1)*.5);
    yF1=round(fixpos(2)*.3);%y axis for upper
    yF2=round(fixpos(2)*.4);%y axis for bottom
    offFletterY=round(fixpos(2)*.3);
    offFletterX=round(fixpos(2)*.77);
    Fpos=[xF1  yF1  xF2   yF2];%F frame
    Kpos=[xF1  yF1+offFletterY  xF2   yF1+offFletterY+(yF2-yF1)];%K frame
    Ppos=[xF1  Kpos(2)+offFletterY  xF2  Kpos(2)+offFletterY+(yF2-yF1)];%P frame
    Spos=[xF1  Ppos(2)+offFletterY  xF2  Ppos(2)+offFletterY+(yF2-yF1)];%S frame
    Hpos=[xF1+offFletterX  yF1  xF1+offFletterX+(xF2-xF1)   yF2];%H frame
    Lpos=[xF1+offFletterX  Kpos(2)  xF1+offFletterX+(xF2-xF1)   Kpos(4)];%L frame
    Qpos=[xF1+offFletterX  Ppos(2)  xF1+offFletterX+(xF2-xF1)   Ppos(4)];%Q frame
    Tpos=[xF1+offFletterX  Spos(2)  xF1+offFletterX+(xF2-xF1)   Spos(4)];%T frame
    Jpos=[Hpos(1)+(Hpos(1)-Fpos(1))  yF1  Hpos(1)+(Hpos(1)-Fpos(1))+(xF2-xF1)   yF2];%J frame
    Npos=[Jpos(1)  Kpos(2)  Jpos(3)   Kpos(4)];%N frame
    Rpos=[Jpos(1)  Ppos(2)  Jpos(3)   Ppos(4)];%R frame
    Ypos=[Jpos(1)  Spos(2)  Jpos(3)   Spos(4)];%Y frame
    
    [~, ~, textbounds5]=DrawFormattedText(w, 'հ', screenRect(3)*0.45, screenRect(4)*0.67, 0);
    blankpos= [textbounds5(1)-offdisX  textbounds5(2)   textbounds5(3)+offdisX  textbounds5(2)+1.8*(textbounds5(4)-textbounds5(2))];
    letterFramePos=[Fpos;Kpos;Ppos;Spos;Hpos; Lpos;Qpos;Tpos;Jpos;Npos;Rpos;Ypos;blankpos]';%all postions of letter frames in the recall screen.
    shiftpix=20;
    if  width/heighth>=1.5 % ʺϿ߱ȵĵԣ16:9;16:10
        letterPos= letterFramePos;
    else % ʺϿ߱ȵĵԣ5:4;4:3
        letterPos= letterFramePos+shiftpix;
    end
    
    %set position parameters of "޸" button and"" button in the "recall" screen.
    [~, ~, textbounds3]=DrawFormattedText(w, '޸', screenRect(3)*0.235, fixpos(2)*1.8, 0);
    [~, ~, textbounds4]=DrawFormattedText(w, '', screenRect(3)*0.7, fixpos(2)*1.8, 0);
    modifyPos=[textbounds3(1)-offdisX  textbounds3(2)   textbounds3(3)+offdisX  textbounds3(2)+1.8*(textbounds3(4)-textbounds3(2))];
    finishPos=[textbounds4(1)-offdisX  textbounds3(2)    textbounds4(3)+offdisX textbounds3(2)+1.8*(textbounds3(4)-textbounds3(2))];
    modifyFinishPos=[modifyPos;finishPos]';
    
    %set the position of the answer number.
    [~, ~, textboundsNum]=DrawFormattedText(w, num2str(10), fixpos(1), fixpos(2), 0);
    numPosX=round(fixpos(1)-(textboundsNum(3)-textboundsNum(1))/2);
    
    %x positions of letters presented when they are selected in the recall frame.
    ratio=.6:.05:1.15;
    xshowLetters=fixpos(1).*ratio;
    letterDur=.8;%duration of letters
    feedbackDur=2;%duration of feedback
    feedbackPraDur=.5;% duration of feedback in pra2.
    
    %15 math operations in pra (fixed order according to original eprime code).
    mathPra2={ '(12) + 1 = ?','(11) - 1 = ?','(73) - 3 = ?','(43) + 4 = ?','(33) + 2 = ?','(26) - 4 = ?','(89) - 8 = ?','(45) - 5 = ?',...
        '(42) + 6 = ?','(44) + 7 = ?','(82) - 8 = ?' ,'(29) - 9 = ?','(82) + 9 = ?' ,'(38) - 1 = ?','(63) + 1 = ?'};
    mathPra2ans=[3 2 18 16 1 6 64 11 14 12 2 9 7 23 3];% answers of math in pra1.
    mathFirst={'(11)','(21)','(22)','(31)','(33)','(41)','(42)','(44)','(51)','(55)','(61)','(62)','(63)','(66)','(71)','(77)',...
        '(81)','(82)','(84)','(88)','(91)','(93)','(99)','(12)','(13)','(22)','(14)','(15)','(32)','(23)','(16)','(17)','(42)',...
        '(24)','(18)','(33)','(19)','(52)','(25)','(62)','(43)','(34)','(26)','(72)','(27)','(53)','(35)','(82)','(44)','(28)',...
        '(92)','(63)','(36)','(29)'}';% the first section (eg., (12)) of math equations in the main experiments, 54 math questions(difficult 1 and 2) in the original code.
    mathSecond=1:9;
    letters={'F','K','P','S','H','L','Q','T','J','N','R','Y'}';
    feedbackTextPra2={'ȷ','',''};
    introText=zeros(7,1);
    cd introText
    multipleResize=0.8;
    for k=1:length(introText)
        imdataOne=imread([num2str(k) '.JPG']);
        imdataOne=imresize(imdataOne,multipleResize);
        introText(k)=Screen('MakeTexture', w, imdataOne);
    end
    siz = size(imdataOne);
    siz=[siz(2) siz(1)];
    fixpos = [monitor.center(1) monitor.center(2)];
    
    ShowCursor('Arrow'); %must use this line. Or else, the cursor shape is  I Beam because of previous subject information input.
    Screen('FillRect',w,255);
    tvbl=Screen('Flip',w);
    ifi = Screen('GetFlipInterval', w);
    
    %Three practice sessions
    %The first practice section: letter recall task
    introductionText(introText(1),siz);  introductionText(introText(2),siz);    introductionText(introText(3),siz);%presentation of introductions
    ntrial_pra1=4; %4 trials (two times for 2 and 3 letters respectively, according to the orignal eprime code)
    for k=1:ntrial_pra1 %trial:two letters
        xLetter=randperm(length(letters));
        if k==1 || k==2
            xLetter=xLetter(1:2);
        else
            xLetter=xLetter(1:3);
        end
        for kk=1:length(xLetter) %present letters
            tstartLetter=GetSecs;
            while  (GetSecs-tstartLetter)<=letterDur
                Screen('FillRect',w, bkgcol, blackFramePos, penWidth(1));
                Screen('FrameRect',w,0,blackFramePos, penWidth(1));
                DrawFormattedText(w, letters{xLetter(kk)}, 'center', 'center', 0);
                tvbl=Screen('Flip', w, tvbl+(1-0.5)*ifi);
                [keyIsDown, secs, keyCode] = KbCheck;
                if keyIsDown
                    if keyCode(KbName('escape'))
                        error('exit!');
                    end
                end
            end
        end
        
        %Present recall section
        [idxLetter] = recallSection(letters, letterFramePos,letterPos,penWidth, modifyFinishPos,offlineSE,lineWidth,finishPos,xF2,xF1,xshowLetters,modifyPos,blankpos);
        numCorr=0;%compute recalled correct numbers , letters and corresponding order.
        for kk=1:length(xLetter)
            if  xLetter(kk)==idxLetter(kk)
                numCorr=numCorr+1;
            end
        end
        
        %Present feedback
        tstartFeedback=GetSecs;
        while  (GetSecs-tstartFeedback)<=feedbackDur
            Screen('FillRect',w, bkgcol, blackFramePos, penWidth(1));
            Screen('FrameRect',w,0,blackFramePos, penWidth(1));
            DrawFormattedText(w, [double('סĸ')  double(num2str(numCorr)) double('') double('ܵĸ') double(num2str(length(xLetter))) double('')] , 'center' , 'center', 0);%qsm
            tvbl=Screen('Flip', w, tvbl+(1-0.5)*ifi);
        end
    end
    
    %The second practice section:  math operation task.
    introductionText(introText(4),siz);
    rtMathAllPra=[]; %obtain response times to solve the math equations in pra 2 to compute time limits for math equations  in the main Exp.
    resTypeAll=[];
    for k=1:length(mathPra2ans)
        % (1)present math problems
        done=0;
        resRTpra=GetSecs;
        while done==0
            Screen('FillRect',w, bkgcol, blackFramePos, penWidth(1));
            Screen('FrameRect',w,0,blackFramePos, penWidth(1));
            %             DrawFormattedText(w, [double(mathPra2{k}) '\n\n\n\n\n' double('ʱ')], 'center', 'center', 0);
            txt1=[mathPra2{k} '\n\n\n\n\n' 'ʱ'];%qsm
            DrawFormattedText(w, double(txt1), 'center', 'center', 0);%qsm
            tvbl=Screen('Flip', w, tvbl+(1-0.5)*ifi);
            [keyIsDown, secs, keyCode] = KbCheck;
            if keyIsDown
                if keyCode(KbName('escape'))
                    error('exit!');
                end
            end
            [x,y,buttons]=GetMouse(w);
            if  any(buttons)
                done=1;
                rtMathPra = GetSecs-resRTpra;
                rtMathAllPra=[rtMathAllPra;rtMathPra];
            end
            while any(buttons) %release the last mouse press, or else continunous GetMouse will be recorded.
                [xnew,ynew,buttons]=GetMouse(w);
            end
        end
        %(2) present answers
        done=0;
        resType=nan;
        while done==0
            Screen('FillRect',w, bkgcol, blackFramePos, penWidth(1));
            Screen('FrameRect',w,0,blackFramePos, penWidth(1));
            DrawFormattedText(w, num2str(mathPra2ans(k)),numPosX, fixpos(2)*.6, 0);
            DrawFormattedText(w,  double('ȷ'), correctPosX, correctPosY, 0);
            DrawFormattedText(w,  double(''), wrongPosX, correctPosY, 0);
            Screen('FrameRect',w,0,ansFrameLeftPos, penWidth(1));%  to set postions of two response frames
            Screen('FrameRect',w,0,ansFrameRightPos, penWidth(1));
            
            tvbl=Screen('Flip', w, tvbl+(1-0.5)*ifi);
            [keyIsDown, secs, keyCode] = KbCheck;
            if keyIsDown
                if keyCode(KbName('escape'))
                    error('exit!');
                end
            end
            [xnew,ynew,buttons]=GetMouse(w);
            if  any(buttons)
                if xnew>ansFrameLeftPos(1) && xnew<ansFrameLeftPos(3) && ynew>ansFrameLeftPos(2) &&  ynew<ansFrameLeftPos(4)% "ȷ" frame (left)
                    done=1;
                    resType=1;%left response
                    resTypeAll=[resTypeAll;resType ];
                elseif xnew>ansFrameRightPos(1) && xnew<ansFrameRightPos(3) && ynew>ansFrameRightPos(2) &&  ynew<ansFrameRightPos(4)% "" frame (right)
                    done=1;
                    resType=2;%right response
                    resTypeAll=[resTypeAll;resType ];
                else
                    done=1;
                    resTypeAll=[resTypeAll;resType ];
                end
                if ((k==1 || k==3 || k==4|| k==7|| k==9|| k==12|| k==14|| k==15) && (resType==1)) || ((k==2 || k==5 || k==6|| k==8|| k==10|| k==11|| k==13) && (resType==2))
                    feedtext=feedbackTextPra2{1};
                elseif isnan(resType)
                    feedtext=feedbackTextPra2{3};
                else
                    feedtext=feedbackTextPra2{2};
                end
                feedbackStart=GetSecs;
                while (GetSecs-feedbackStart)<=feedbackPraDur
                    Screen('FillRect',w, bkgcol, blackFramePos, penWidth(1));
                    Screen('FrameRect',w,0,blackFramePos, penWidth(1));
                    DrawFormattedText(w, double(num2str(mathPra2ans(k))),numPosX, fixpos(2)*.6, 0);
                    DrawFormattedText(w,  double('ȷ'), correctPosX, correctPosY, 0);
                    DrawFormattedText(w,  double(''), wrongPosX, correctPosY, 0);
                    DrawFormattedText(w,  double(feedtext), 'center', fixpos(2)*1.5, [0 0 255]);
                    Screen('FrameRect',w,0,ansFrameLeftPos, penWidth(1));%  to set postions of two response frames
                    Screen('FrameRect',w,0,ansFrameRightPos, penWidth(1));
                    tvbl=Screen('Flip', w, tvbl+(1-0.5)*ifi);
                end
            end
            while any(buttons)
                [xnew,ynew,buttons]=GetMouse(w);
            end
        end
    end
    
    %The third practice section: letter recall task + math operation task.
    introductionText(introText(5),siz); %instruction for pra3
    introductionText(introText(6),siz);
    mathMaxDur=mean(rtMathAllPra(~isnan(resTypeAll)))+2.5*std(rtMathAllPra(~isnan(resTypeAll))); %calculate each individual's mean time required to solve the math equation for double task trials. time limit : plus 2.5 SD
    %begin to present math equations  for pra3 and normal Exp.
    countMath=1;
    speed_errors=0;
    whichAnsAll=[];
    trialOrder=Shuffle(repmat(3:7,1,3));%75 math, 15 set sizes ranging from 3 to 7.
    for kkkk=1:2 %1,for pra; 2, for the normal experiment.
        if  kkkk==1
            idblock=3;%3 blocks for pra3.
            idtrials=2;%2 trials for each block.
            ncorrMathAll=[];% number of correct maths in pra3.
            nMathAll=[];% number of all maths presented in pra3.
        else %normal experiment
            introductionText(introText(7),siz);%instruction for normal experiment.
            idblock=length(trialOrder); %15 set sizes ranging from 3 to 7.
            mathfullAll={'[]'};%save full math equations ,75 math.
            ncorrMathAll=[];% number of correct maths .
            nMathAll=[];% number of all maths presented.
            answerAll=[];% all answers presented,including negative but not in the normal exp (use abs)
            letterAll=[];% index of all letters presented
            Absolute_scoresAll=[];%perfectly recalled sets for normal Exp.
            numCorrAll=[];
            rtMathAll=[]; %RT of math problems.
            rtAnswerAll=[];%RT of answers.
            rtRecallAll=[];%duration of recall.
        end
        for k=1:idblock
            xLetter=randperm(length(letters));
            resTypeBlock=[];% which button was pressed  (ȷor )
            whichAnsBlock=[];%1,present correct answers; 2, present wrong answers.
            if  kkkk==1
                xLetter=xLetter(1:2);
            elseif kkkk==2
                idtrials=trialOrder(k);
                xLetter=xLetter(1:idtrials);
                letterAll=[letterAll xLetter];% all letters presented
            end
            for kk=1:idtrials
                % (1)present math problems
                done=0;
                idMath1=randi(length(mathFirst)); %select first section of a math equation randomly
                idMath2=randi(length(mathSecond)); %select second section of a math equation randomly
                secondSign=randi(2);%1 is postive sign; 2 is negative sign
                if secondSign==2 % to prevent negative values for ans of math equations
                    if idMath1<=23%1-23 numbers are division in the mathFirst.
                        if str2double(mathFirst{idMath1}(2))/str2double(mathFirst{idMath1}(4))<idMath2
                            idMath2=randi(str2double(mathFirst{idMath1}(2))/str2double(mathFirst{idMath1}(4)));
                        end
                    else
                        if str2double(mathFirst{idMath1}(2))*str2double(mathFirst{idMath1}(4))<idMath2
                            idMath2=randi(str2double(mathFirst{idMath1}(2))*str2double(mathFirst{idMath1}(4)));
                        end
                    end
                end
                
                if secondSign==1
                    othersection= [ ' + ' num2str(mathSecond(idMath2))  ' = ?'];
                else
                    othersection= [ ' - ' num2str(mathSecond(idMath2))  ' = ?'];
                end
                mathStart=GetSecs;
                txt2=[mathFirst{idMath1}   othersection  '\n\n\n\n\n' 'ʱ'];%qsm
                while (GetSecs-mathStart<=mathMaxDur) && done==0
                    Screen('FillRect',w, bkgcol, blackFramePos, penWidth(1));
                    Screen('FrameRect',w,0,blackFramePos, penWidth(1));
                    DrawFormattedText(w, double(txt2), 'center', 'center', 0);
                    tvbl=Screen('Flip', w, tvbl+(1-0.5)*ifi);
                    [keyIsDown, secs, keyCode] = KbCheck;
                    if keyIsDown
                        if keyCode(KbName('escape'))
                            error('exit!');
                        end
                    end
                    [x,y,buttons]=GetMouse(w);
                    if  any(buttons)
                        done=1;%end this trial, ensure one press to a resp
                        if kkkk==2
                            rtMath = GetSecs-mathStart;
                            rtMathAll=[rtMathAll rtMath];
                        end
                    end
                end
                while any(buttons)
                    [xnew,ynew,buttons]=GetMouse(w);
                end
                if kkkk==2
                    if done==0 %no response in max time limit
                        speed_errors=speed_errors+1;
                        rtMathAll=[rtMathAll nan];
                    end
                end
                
                %(2) present answers
                if done==1 % run when having responses.
                    done=0;
                    whichAns=randi(2);%1,present correct answers; 2, present wrong answers.
                    whichAnsBlock=[whichAnsBlock whichAns];
                    whichAnsAll=[whichAnsAll whichAns];
                    if idMath1<=23%1-23 numbers are division in the mathFirst.
                        if  secondSign==1%1-9 numbers are addition in the mathSecond.
                            answer=str2double(mathFirst{idMath1}(2))/str2double(mathFirst{idMath1}(4))+mathSecond(idMath2);
                        else
                            answer=str2double(mathFirst{idMath1}(2))/str2double(mathFirst{idMath1}(4))-mathSecond(idMath2);
                        end
                    else
                        if  secondSign==1%1-9 numbers are addition in the mathSecond.
                            answer=str2double(mathFirst{idMath1}(2))*str2double(mathFirst{idMath1}(4))+mathSecond(idMath2);
                        else
                            answer=str2double(mathFirst{idMath1}(2))*str2double(mathFirst{idMath1}(4))-mathSecond(idMath2);
                        end
                    end
                    if whichAns==2%present incorrect ans
                        addSubtract=randi(2);
                        if addSubtract==1%add
                            answer=answer+randi(9);
                        else%substract
                            answer=answer-randi(9);
                        end
                    end
                    if kkkk==2
                        answerAll=[answerAll answer];% all answers presented
                    end
                    resRT=GetSecs;
                    while done==0
                        Screen('FillRect',w, bkgcol, blackFramePos, penWidth(1));
                        Screen('FrameRect',w,0,blackFramePos, penWidth(1));
                        DrawFormattedText(w, num2str(abs(answer)),numPosX, fixpos(2)*.6, 0);
                        DrawFormattedText(w,  double('ȷ'), correctPosX, correctPosY, 0);
                        DrawFormattedText(w,  double(''), wrongPosX, correctPosY, 0);
                        Screen('FrameRect',w,0,ansFrameLeftPos, penWidth(1));%  to set postions of two response frames
                        Screen('FrameRect',w,0,ansFrameRightPos, penWidth(1));
                        tvbl=Screen('Flip', w, tvbl+(1-0.5)*ifi);
                        [keyIsDown, secs, keyCode] = KbCheck;
                        if keyIsDown
                            if keyCode(KbName('escape'))
                                error('exit!');
                            end
                        end
                        [xnew,ynew,buttons]=GetMouse(w);
                        if  any(buttons)
                            if xnew>ansFrameLeftPos(1) && xnew<ansFrameLeftPos(3) && ynew>ansFrameLeftPos(2) &&  ynew<ansFrameLeftPos(4)% "ȷ" frame (left)
                                done=1;
                                resType=1;%left response
                                resTypeBlock=[resTypeBlock resType ];
                            elseif xnew>ansFrameRightPos(1) && xnew<ansFrameRightPos(3) && ynew>ansFrameRightPos(2) &&  ynew<ansFrameRightPos(4)% "" frame (right)
                                done=1;
                                resType=2;%right response
                                resTypeBlock=[resTypeBlock resType ];
                            end
                            rtAnswer = GetSecs-resRT;
                            if kkkk==2
                                rtAnswerAll=[rtAnswerAll rtAnswer];
                            end
                        end
                        while any(buttons)
                            [xnew,ynew,buttons]=GetMouse(w);
                        end
                    end
                else
                    resType=3;%no response
                    whichAnsBlock=[whichAnsBlock nan];
                    resTypeBlock=[resTypeBlock resType];
                    if kkkk==2
                        answerAll=[answerAll nan];% all answers presented
                    end
                end
                %(3)present letters
                tstartLetterPra3=GetSecs;
                while  (GetSecs-tstartLetterPra3)<=letterDur
                    Screen('FillRect',w, bkgcol, blackFramePos, penWidth(1));
                    Screen('FrameRect',w,0,blackFramePos, penWidth(1));
                    DrawFormattedText(w, letters{xLetter(kk)}, 'center', 'center', 0);
                    tvbl=Screen('Flip', w, tvbl+(1-0.5)*ifi);
                    [keyIsDown, secs, keyCode] = KbCheck;
                    if keyIsDown
                        if keyCode(KbName('escape'))
                            error('exit!');
                        end
                    end
                end
                if kkkk==2
                    mathfullAll{countMath}=[mathFirst{idMath1} othersection];
                    countMath=countMath+1;
                end
            end
            %Present recall section.
            recallStart=GetSecs;
            [idxLetter] = recallSection(letters, letterFramePos,letterPos,penWidth, modifyFinishPos,offlineSE,lineWidth,finishPos,xF2,xF1,xshowLetters,modifyPos,blankpos);
            if kkkk==2
                rtRecallAll=[rtRecallAll GetSecs-recallStart];
            end
            %Present feedback.
            numCorr=0;%compute recalled correct numbers , letters and corresponding order.
            numIncorrMath=0;% numbers of wrong math equations computed
            for kkk=1:length(xLetter)
                if  xLetter(kkk)==idxLetter(kkk)
                    numCorr=numCorr+1;
                end
                if  whichAnsBlock(kkk)~=resTypeBlock(kkk)
                    numIncorrMath=numIncorrMath+1;
                end
            end
            
            ncorrMathAll=[ncorrMathAll  length(xLetter)-numIncorrMath];
            nMathAll=[nMathAll  length(xLetter)];
            corrRate=sum(ncorrMathAll)/sum(nMathAll);
            if kkkk==2
                numCorrAll=[numCorrAll numCorr];
                if numCorr== length(xLetter)
                    Absolute_scoresAll=[Absolute_scoresAll numCorr];
                end
            end
            
            tstartFeedback=GetSecs;
            txt3=['ס' num2str(numCorr) 'ĸ'   'һ' num2str(length(xLetter)) 'ĸ' '\n\n\n\n'  'һѧʽУٴ뾡ȷ'];%qsm
            txt4=['ס'  num2str(numCorr) 'ĸ'   'һ' num2str(length(xLetter)) 'ĸ' '\n\n\n\n'  '' num2str(numIncorrMath) 'ѧʽ'];
            while  (GetSecs-tstartFeedback)<=feedbackDur
                if numIncorrMath>=3
                    DrawFormattedText(w, double(txt3) , 'center' , 'center', 0);%qsm
                else
                    DrawFormattedText(w, double(txt4) , 'center' , 'center', 0);%qsm
                end
                DrawFormattedText(w, [num2str(round(corrRate*100)) '%'   ],  round((2*fixpos(1)-fixpos(1)/7)), round(fixpos(2)/10), [255 0 0]);
                tvbl=Screen('Flip', w, tvbl+(1-0.5)*ifi);
                [keyIsDown, secs, keyCode] = KbCheck;
                if keyIsDown
                    if keyCode(KbName('escape'))
                        error('exit!');
                    end
                end
            end
        end
    end
    
    
    %compute scores , see Unsworth et al2005.
    Absolute_scores=sum(Absolute_scoresAll);    %sum of all perfectly recalled sets.
    Total_scores = sum(numCorrAll);% "total number correct": total numbers of letters recalled in the correct position.
    Math_errors=sum(nMathAll)-sum(ncorrMathAll);% "Math errors" :  total numbesr for errors, breaking  into speed errorsandaccuracy errors.
    accuracy_errors=Math_errors-speed_errors; %  errors for math operation. speed_errors: ran out of time in attempting to solve a given math operation.
    
    cd(homedir);
    cd Data
    cd(nsub_nTest{1})
    datafileName=[nsub_nTest{1},'-',nsub_nTest{2},'-',date,'-',strrep(datestr(now,13),':','-')];
    DurFinishTaskSec= toc;
    save(datafileName);
    
    %also save main results in txt format.
    fidTxt=fopen([datafileName '.txt'],'wt');
    content={double('ܹȵ÷: ') ,double('Թȵ÷:'), double(':') double('㳬ʱ:') ,double(':') ,double('ѧʽȷ:')};
    scoreAospan=[Total_scores  Absolute_scores   Math_errors   speed_errors  accuracy_errors   round(corrRate*100) ];
    fprintf(fidTxt,'%s',[double('ԣ'), nsub_nTest{1}]);fprintf(fidTxt,'\n');
    for  k=1:6
        if  k<6
            fprintf(fidTxt,'%s',[content{k}, num2str(scoreAospan(k)) ]);
            fprintf(fidTxt,'\n');
        elseif k==6
            fprintf(fidTxt,'%s',[content{k}, num2str(scoreAospan(k)) '%' ]);
        end
    end
    fclose(fidTxt);
    
    DrawFormattedText(w, double('ϣлл룡'), 'center', fixpos(2), 0);
    Screen('Flip',w);
    KbWait;
    while KbCheck; end % Wait until all keys are released.
    
    %show results
    txt5=['ܹȵ÷: '  num2str(Total_scores) '\n\n'   'Թȵ÷:'  num2str(Absolute_scores ) '\n\n' ...
        ':'  num2str(Math_errors) '\n\n'  '㳬ʱ:'  num2str(speed_errors) '\n\n' ':'  num2str(accuracy_errors)   '\n\n' 'ѧʽȷ:'  num2str(round(corrRate*100)) '%' '\n\n\n\n\n\n\n\n'  ...
        '˳!'];%qsm
    DrawFormattedText(w,double(txt5), fixpos(1)/2, fixpos(2)-fixpos(2)/2, 0);%qsm
    Screen('Flip',w);
    KbWait;
    disp([ double('ܹȵ÷: ') num2str(Total_scores) ';  ' double('Թȵ÷:')  num2str(Absolute_scores ) ';  '  double(':')  num2str(Math_errors) ';  '  double('㳬ʱ:')  num2str(speed_errors) ';  ' double(':')  num2str(accuracy_errors) ])
    rmpath(pwd);
    Screen('CloseAll');
    cd(homedir);
    commandwindow
catch ME
    Screen('LoadNormalizedGammaTable',w,monitor.oldclut,2);
    for i=1:length(ME.stack)
        ME.stack(i)
    end
    Priority(0);
    Screen('CloseAll');
    ShowCursor;
    rmpath(pwd);
    cd(homedir);
    rethrow(ME);
end%try..catch..




